<?PHP

// -----------------------------------------------------------------------------
// Suche von FreieTonne Positionen
// -----------------------------------------------------------------------------
//
// Dieses Programm wird als Popup-Fenster von OpenLayer aus gestartet.
// Hier können Sie eine Suche nach Positionen innerhalb des Namens,
// Beschreibung oder ID-Nummer ausführen.
//
// Ergebnisse werden als "Link" für das OpenLayer-Fenster übergeben.
// Daher funktionieren diese nicht, wenn das Fenster nicht als Popup existiert.
//
// Als Quelle wird die FreieTonne-Datenbank genommen.
// Bei offline/ externer Nutzung, wird hingegen aus einer Datei mit
// den FreieTonne Positionen herangezogen: ft_osm_pois.csv
// HINWEIS: letzteres ist noch in Entwicklung
//
// -----------------------------------------------------------------------------

$poisuche = '';

// Datenbank-Verbindung -----------------------------------------------------
$mysql = '../admin/_cfg.php';
$suche = FALSE;
$htm = '';

$zoom = 11;
if(isset($_GET['zoom']) AND @ctype_digit($_GET['zoom'])) { $zoom = $_GET['zoom']; }
if(isset($_POST['zoom']) AND @ctype_digit($_POST['zoom'])) { $zoom = $_POST['zoom']; }


if(isset($_POST['poisuche'])) {

   // Suchstring bearbeiten
   $suchstring = trim($_POST['poisuche']);
   if(get_magic_quotes_gpc()) { $suchstring = stripslashes($_POST['poisuche']); }
   // Wenn leer, dann zurück zur Seite
   if(!$suchstring) { header("Location: ft-suche.php"); exit; }
   // Rückgabe an Formular
   $poisuche = htmlspecialchars($suchstring);

   // Array mit Begriffen erstellen
   $begriffe = explode(" ",$suchstring);
   foreach($begriffe as $k => $b) {
      if(strlen($b) < 2) {
         unset($begriffe[$k]);
      }
   }
   if($begriffe) {
      $poisuche = htmlspecialchars(implode(' ',$begriffe));
      $suche = TRUE;
   } else {
      $suche = FALSE;
   }


}


if($suche) {
   $sqls = array();
   // FT-DB check
   if(is_file($mysql)) {
      include($mysql);
   
      $osmids = array();
      foreach($begriffe as $begriff) {
         $begriff = addslashes($begriff);
         $sqls[] = "(id = '$begriff' OR name LIKE '%$begriff%' OR beschreibung LIKE '%$begriff%')";
         if(ctype_digit($begriff)) {
            $osmids[] = "osmid = '$begriff' OR osmid_last = '$begriff'";
         }
      }
      $sql  = implode(" AND ",$sqls);
      if($osmids) {
         $sql .= " OR (".implode(' OR ',$osmids).")";
      }
      
      $res = mysql_query("SELECT id,icon,ldez,bdez,name FROM mod_gps WHERE deleted != 'y' AND $sql ORDER BY name");
      $anzahl = mysql_num_rows($res);
      $htm .= '<br /><br ><hr /><b>'.$anzahl.' Treffer - FreieTonne</b><br /><br />';
      
      if($anzahl) {
         $htm .= '
         <table cellspacing="0" cellpadding="0" border="0" style="width:100%;">';
         
         while($dat = mysql_fetch_assoc($res)) {
            $htm .= '<tr>
            <td class="id">'.$dat['id'].'</td>
            <td class="icon"><img src="icons/'.$dat['icon'].'.png" width="16" height="16" alt="" title="" /></td>
            <td class="name"><a onclick="goTo(\'index.php?lat='.$dat['bdez'].'&lon='.$dat['ldez'].'&zoom='.$zoom.'\');">'.$dat['name'].'</a></td>
            </tr>';
         }
         
         $htm .= '</table>';
      } else {
         $htm .= 'Es wurden keine Treffer mit Ihren angegebenen Suchbegriffen erzielt.';
      }
      

   // Offline/ Extern = Suche in Datei -----------------------------------------
   } else {
   
      $csv_datei = 'ft_osm_pois.csv';
      $hits = 0;
      $treffer_ids = array();
      $treffer_html = array();
      $treffer_sort = array();

      if(is_file($csv_datei)) {
         // Datei einlesen
         $tonnen = file($csv_datei);
         // Suchen
         foreach($tonnen as $ton) {
            $treffer = FALSE;
            foreach($begriffe as $begriff) {
               if(stripos($ton,$begriff) !== FALSE) {
                  $treffer = TRUE;
               } else {
                  $treffer = FALSE; break;
               }
            }
            
            if($treffer) {
               $dat = explode("\t",$ton);
               // Wenn noch nicht bereits aufgenommen
               if(!in_array($dat[0],$treffer_ids)) {
                  $hits++;
                  $treffer_ids[]  = $dat[0];
                  $treffer_sort[] = strtolower($dat[5]);
                  $treffer_html[] = '<tr>
                  <td class="id">'.$dat[0].'</td>
                  <td class="icon"><img src="icons/'.$dat[3].'.png" width="16" height="16" alt="" title="" /></td>
                  <td class="name"><a onclick="goTo(\'index.php?lat='.$dat[2].'&lon='.$dat[1].'&zoom='.$zoom.'\');">'.htmlspecialchars($dat[5]).'</a></td>
                  </tr>';
               }
            }
         }

      } else {
         $htm .= 'Die Datei, welche die Daten der FreienTonne zum offline
         Arbeiten bereithält, existiert nicht (ft_osm_pois.csv)<br /><br />
         Sie können diese unter folgender Adresse herunterladen:<br />
         <a href="http://www.freietonne.de/seekarte/ft_osm_pois.csv">
         http://www.freietonne.de/seekarte/ft_osm_pois.csv</a><br /><br />

         Speichern Sie die Datei im gleichen Verzeichnis, in der sich auch die
         Datei "ft-suche.php" befindet (Hauptverzeichnis).';
      }


      // --------------------------------------------------------------------------
      // Suche in Offline-POIs (GPX)
      // --------------------------------------------------------------------------
      // Holen der POI-Information
      // Auslesen der Datei ft-selfpois-offline.gpx
      if(is_file('ft-selfpois-offline.gpx')){
        $gpx = file_get_contents('ft-selfpois-offline.gpx');
        $xml = new SimpleXMLElement($gpx);
  
        // Durchlauf der POIs
        foreach($xml->wpt AS $pos) {
           $suchstring = $pos->name.' '.$pos->cmt.' '.$pos->desc;
           $treffer = FALSE;
           foreach($begriffe as $begriff) {
              if(stripos($suchstring,$begriff) !== FALSE) {
                 $treffer = TRUE;
              } else {
                 $treffer = FALSE; break;
              }
           }
  
           if($treffer) {
              $hits++;
              $treffer_ids[]  = $pos->name;
              $treffer_sort[] = strtolower($pos->name);
              $treffer_html[] = '<tr>
              <td class="id">'.$pos->ftid.'</td>
              <td class="icon"><img src="icons/'.$pos->sym.'.png" width="16" height="16" alt="" title="" /></td>
              <td class="name"><a onclick="goTo(\'index.php?lat='.$pos['lat'].'&lon='.$pos['lon'].'&zoom='.$zoom.'\');">'.htmlspecialchars($pos->name).'</a> <sup>GPX</sup></td>
              </tr>';
           }
        }
      }


      // -----------------------------------------------------------------------
      // Ausgabe der Sucheergebnisse in POIs (csv und gpx)
      // -----------------------------------------------------------------------
      if($hits) {
         // Sortieren
         asort($treffer_sort); reset($treffer_sort);

         $htm .= '<br /><br ><hr /><b>'.$hits.' Treffer - FreieTonne (offline)</b><br /><br />
         <table cellspacing="0" cellpadding="0" border="0" style="width:100%;">';
         foreach($treffer_sort as $key => $trash) {
            $htm .= $treffer_html[$key];
         }
         $htm .= '</table>
         <br /><span style="font-size:10px;">Hinweis: Die mit GPX gekennzeichneten Suchergebnisse, sind von Ihnen selbst erstellte Positionen, welche sich in Ihrer lokalen GPX-Datei befinden.</span>';

      } else {
         $htm .= 'Es wurden keine Treffer mit den angegebenen Suchbegriffen erzielt.';
      }



   } // Wenn Offline ENDE



   // --------------------------------------------------------------------------
   // Suche nach Orten in Deutschland
   // --------------------------------------------------------------------------
   // Suche findet immer in einer Datei statt "openGeoDB.csv",
   // unabhängig von off- oder online.
   $orte = file('openGeoDB.csv');
   $ortstreffer = '';
   foreach($orte as $zeile) {
      $ortcheck = TRUE;
      foreach($begriffe as $begriff) {
         if(stripos(strtolower($zeile),strtolower($begriff)) !== FALSE) {
         } else { $ortcheck = FALSE; break; }
      }
      
      if($ortcheck) {
         $odat = explode("\t",trim($zeile));
         $ortstreffer .= '- <a onclick="goTo(\'index.php?lat='.$odat[1].'&lon='.$odat[2].'&zoom='.$zoom.'\');">'.htmlspecialchars($odat[0]).'</a><br />'."\r\n";
      }
   }
   if($ortstreffer) {
      $htm .= '<br /><br /><b>Gefundene Ortsnamen in Deutschland</b><br />
      (Positionsdaten teilweise ungenau, nutzen Sie niedrige Zoomstufen)<br /><br />'.$ortstreffer;
   }


   // --------------------------------------------------------------------------
   // Berliner Straßen ------------------------------------------------------
   // --------------------------------------------------------------------------
   // Suche in Berliner Straßen, zunächst nur Online, da Test
   if(is_file($mysql)) {
      if(is_file('berlin.csv')) {
         $berlin = fopen('berlin.csv',"r");
         $count_needed = count($begriffe);
         $streets = array();
         while(!feof($berlin)) {
            $line = fgets($berlin);
            $check_count=0;
            foreach($begriffe as $b) {
               if(strpos(strtolower($line),strtolower($b)) !== FALSE) { $check_count++; }
            }
            if($check_count >= $count_needed) {
               $streets[] = explode('|',trim($line));
            }
         }
         fclose($berlin);

         if($streets) {
            $htm .= '<br /><br />
            <b>Treffer innerhalb Berliner Straßen:</b>
            <ul>';
            foreach($streets as $s) {
               $htm .= '<li><a onclick="goTo(\'index.php?lat='.$s[2].'&lon='.$s[3].'&zoom='.$zoom.'\');">'.htmlspecialchars($s[0]).' ('.htmlspecialchars($s[1]).')</a></li>';
            }
            $htm .= '</ul>';
         }
      }
   }

}





// -----------------------------------------------------------------------------
// HTML-Ausgabe
// -----------------------------------------------------------------------------
$out = '
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html
         PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
         "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
<head>
   <title>FreieTonne - OSM_POI_Suche</title>

   <meta http-equiv="content-type" content="application/xhtml+xml;charset=utf-8" />
   <meta name="content-language" content="de" />
   <meta name="title" content="FreieTonne - Kostenloses Seezeichen-Verzeichnis" />
   <meta name="author" content="Jan Jesse, Berlin, Germany" />
   <meta name="description" content="Entwicklung eines freien Verzeichnisses von See- und Schifffahrtszeichen durch freie Mitarbeit eines jeden Skippers, nur mit Hilfe eines Computers und GPS-Gerätes." />

   <meta name="keywords" content="Seefahrtszeichen, Seezeichen, Seekarte, Karte, Gewässerkarte, Schifffahrtszeichen, Schiffahrtszeichen, Tonnen, Tonne, Freie, Freietonne, Leuchttonne, Stumpftonne, Spitztonne, Kugeltonne, Spierentonne, Tonnenverzeichniss, Tonnenindex, Pricke, Leuchtturm, Hauptzeichen, Verbotszeichen, Gebotszeichen, Community, Tonnensammler, kartographieren, Wasserwanderatlas, Navigation, Ostsee, Müritz, Binnenwasserstrassen, Nordsee, Spree, Schleuse, Schleusen, Wehr, Skipper, Törnplanung, Hafen, Hafenlotse, Lotse, GPS, GPS-Geräte, Navigationsgerät, GPS-Gerät, Kartenplotter" />
   <meta name="copyright" content="2008 Jan Jesse" />
   <meta name="page-type" content="Information" />
   <meta name="revisit-after" content="1 days" />
   <meta name="robots" content="follow" />

   <meta name="apple-mobile-web-app-capable" content = "yes" />
   <meta name="apple-mobile-web-app-status-bar-style" content = "black-translucent" />

   <meta name="viewport" content="user-scalable=no, width=350">
   <!--
   <meta name="viewport" content = "initial-scale = 1.0, user-scalable = no" /> 
   -->

   <style type="text/css">
   html,form,table,div { margin:0px; padding:0px; }
   body {
      margin:0px; padding:20px;
      font-family: Verdana, Arial, Helvetica;
      font-size: 12px;
   }
   td.id {
      text-align: right;
      padding-right: 5px;
   }
   td.icon {
      padding-left: 5px;
      padding-right: 10px;
      text-align: center;
   }
   td.name {
      width: 100%;
   }
   a:link, a:active, a:visited, a:hover {
      text-decoration: none;
   }
   </style>
   <script type="text/javascript">
      function goTo(URL) {
        location = URL;
         //document.location = URL;
         //opener.parent.document.location = URL;
         //window.close();
      }
      function init() {
         document.getElementById(\'poisuche\').focus();
      }
   </script>

</head>

<body onload="init();">

      <b>Suche Ort oder Seezeichen:</b><br /><br />
      <form method="post" action="ft-suche.php" id="admin" accept-charset="utf-8">
      <input type="text" id="poisuche" style="width:300px; max-width:80%" name="poisuche" value="'.$poisuche.'" />
      <input type="hidden" name="zoom" value="'.$zoom.'" />
      <input type="submit" name="submit" value="Suchen" /><br />
      <span style="font-size: 10px;">Hinweis: Mindestens drei Zeichen pro Suchbegriff</span>
      </form>
      
      '.$htm.'
      <br /><button onclick="history.back();">Zur&uuml;ck</button></p>
</body></html>
';
header('content-type: text/html; charset=utf-8');
echo $out; exit;
?>
