<?PHP

// -----------------------------------------------------------------------------
// Zusammenstellung von POIS für OpenLayer
// -----------------------------------------------------------------------------
//
// Dem Programm wird eine Fläche (in Form von 2 Eckpunkten in Geo-Koordinaten
// (dezimal)) übergeben, und sucht entsprechende Positionen aus der FreienTonne
// heraus, welche sich in diesem Bereich befinden.
//
// Als Quelle wird hierbei entweder die Datenbank der FreienTonne genutzt,
// oder wenn Sie das OSM extern bzw. offline nutzen, eine Quelldatei mit
// allen aktiven Positionen der FreienTonne "ft_osm_pois.csv".
// Diese muss sich im gleichem Verzeichnis wie dieses Script befinden.
//
// Das Programm gibt eine CSV-Datei zurück, in dem sich alle gefundenen
// Positionen befinden. Diese entspricht den Vorlagen von OpenLayer
// für die Klasse "OpenLayers.Layer.Text" (9 Jan 2009)
//
// -----------------------------------------------------------------------------
// Konfiguration
// -----------------------------------------------------------------------------
//
// Die Anzeigenhoehen sind hardcodiert!!
// Bei der FreieTonne existieren 3 Anzeigenhöhen für die Positionen
// 1 = Immer sichtbar
// 2 = Ab großer Höhe sichtbar
// 3 = Ab niedriger Höhe sichtbar
// -----------------------------------------------------------------------------

// GoogleEarth liefert: BBOX=-122.522859,37.721792,,-122.359974,37.813426
$bbox = explode(",",$_GET['BBOX']);
$ldez1 = $bbox[0];
$ldez2 = $bbox[2];
$bdez1 = $bbox[3];
$bdez2 = $bbox[1];

//if (abs($bdez1-$bdez2)> 0.17) {
if (abs($bdez1-$bdez2)> 1.9) {
      $KMLFILE='<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://earth.google.com/kml/2.2">
<Document xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<name>FreieTonne - Gewaesserzeichen</name>
<bindingbox>$ldez1 $ldez2 $bdez1 $bdez2</bindingbox>
' ;
$KMLFILE .='
</Document>
</kml>';

header("Content-Type: text/plain; charset=utf-8");
//echo 'lat'."\t".'lon'."\t".'title'."\t".'description'."\t".'iconSize'."\t".'iconOffset'."\t".'icon'."\r\n";
//echo $OP_CSV;
echo $KMLFILE;
exit;

//  $out = array('','','');
//  return $out;

}elseif (abs($bdez1-$bdez2)> 0.8){
    $zzz=1;
}elseif (abs($bdez1-$bdez2)> 0.17){
    $zzz=2;
}else{
    $zzz=3;
}
$logofile = '/var/www/freietonne/logo.png';
if(is_file($logofile)) {
    $logofile="http://www.freietonne.de/logo.png" ;
}else{
    $logofile="http://localhost:85/logo.png" ;
}

// MySQL-Server Anmelde-Datei
$mysql = '../admin/_cfg.php';
$OP_CSV = '';


   function dez2grad($dez) {
      if(is_numeric($dez)) {
         $dez = abs($dez);

         $grad  = (int) $dez;
         $temp1 = ($dez - $grad) * 60;
         $min   = (int) $temp1;
         $temp2 = ($temp1 - $min) * 60;
         $sek   = round( $temp2 ,2);

         if($sek >= 60) { $min++; $sek = 0; }
         if($min >= 60) { $grad++; $min = 0; }

         $out = array($grad,$min,$sek);
      } else {
         $out = array('','','');
      }
      return $out;
   }

// -----------------------------------------------------------------------------
// Datei vorhanden = Daten von MYSQL freietonne.de DB beziehen
// -----------------------------------------------------------------------------

   
   // GoogleEarth liefert: BBOX=-122.522859,37.721792,,-122.359974,37.813426
      $bbox = explode(",",$_GET['BBOX']);
      $ldez1 = $bbox[0];
      $ldez2 = $bbox[2];
      $bdez1 = $bbox[3];
      $bdez2 = $bbox[1];


      $KMLFILE='<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://earth.google.com/kml/2.2">
<Document xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<name>FreieTonne - GewÃ¤sserzeichen</name>

<ScreenOverlay>
    <name>Seekarte FreieTonne</name>
    <Icon>
      <href>' . $logofile . '</href>
    </Icon>
    <overlayXY x="0" y="1" xunits="pixels" yunits="pixels"/>
    <screenXY x="15" y="50" xunits="pixels" yunits="pixels"/>
    <rotationXY x="0" y="0" xunits="fraction" yunits="fraction"/>
    <size x="0" y="0" xunits="fraction" yunits="fraction"/>
</ScreenOverlay>
  
' ;
      $anzeigenhoehe = 'AND anzeigenhoehe = 3';


if(is_file($mysql)) {
      include($mysql);
      $sql  = "SELECT * FROM mod_gps WHERE deleted != 'y' AND \r\n";
      $sql .= "(ldez + 0) > '$ldez1' AND (ldez + 0) < '$ldez2' AND \r\n";
      $sql .= "(bdez + 0) > '$bdez2' AND (bdez + 0) < '$bdez1' \r\n";
      //$sql .= $anzeigenhoehe;
	
      $res_csv = mysql_query($sql) or die(mysql_error());
      
      if(mysql_num_rows($res_csv)) {

         while($dat_csv = mysql_fetch_assoc($res_csv)) {
          $scale=0.5;
          $labelscale=0;
          
          if ($dat_csv['anzeigenhoehe'] <=  $zzz){ 
           
            // Prüfen ob ein Bild mit Namen existiert, dann diese nehmen;
            $yd = ''; if($dat_csv['show_beschreibung'] == 'y') { $yd = '-yd'; }
            $textbild = 'iconnamen'.$yd.'/'.$dat_csv['id'].'.png';
            if(is_file($textbild)) {
               $icon = $textbild;
            } else {
               $icon = 'http://www.freietonne.de/ft_icons/png'.$yd.'/'.$dat_csv['icon'].'.png';
            }
        
            if((is_file($textbild)) and ($dat_csv['icon'] != 116)) {
                  $icon = $textbild;
                  //$scale=1;
                  //if ($zzz==2){$scale=0.5;}
                  
               $imgsize = getimagesize($textbild);
               $size  = $imgsize[0].','.$imgsize[1]."\t";
               $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
                  
                  
		           $scale=$size/60*$zzz;
            } else {
                  $icon = 'icons'.$yd.'/'.$dat_csv['icon'].'.png';
            }

            // Tiefenangaben sollen nicht angezeigt werden
            if(($dat_csv['icon'] == '116') or ($dat_csv['icon'] == '122')){
                $icon = 'http://www.freietonne.de/ft_icons/png/blue-dot.png';
                $labelscale=0.5;
             
            }
              //Label nur text (115) anzeigen
              if($dat_csv['icon'] == '115'){
                 $icon='';
                 $labelscale=0.6;
              }
            
           }else{
                //$icon = 'http://www.freietonne.de/ft_icons/png/blue-dot.png';
                $icon='';
                $labelscale=0.5;
                
          }


	   if ($dat_csv['link'] == ''){
		$internet="";
	   }else{
	        $internet='<br><a href="' . $dat_csv['link'] . '">mehr: ...</a><br>';
	   }
            $name=htmlspecialchars($dat_csv['name']);
            $breite=$dat_csv['bdez'];
            $laenge=$dat_csv['ldez'];
            $id=$dat_csv['id'];
            $beschreibung=htmlspecialchars($dat_csv['beschreibung']);
            
            $KMLFILE .='
      <Placemark>
      	 <name>'.$name.'</name>
      	 <label>'.$name.'</label>
      	 <description><![CDATA[<center>Breite: '.$breite.'<br />L&auml;nge: '.$laenge.'<br />
         <br />
         <a href="http://www.freietonne.de/index.php?site=38&infotyp=1&editgps='.$id.'">Bearbeiten</a>
         <a href="http://www.freietonne.de/index.php?site=38&infotyp=1&delgps='.$id.'">L&ouml;schen</a>
         <br>FT-ID: '.$id.'<br />'.$beschreibung.'
	 ' . $internet . '</center>]]></description>
      		
      		<Style>
      			<IconStyle>
      				<scale>'.$scale.'</scale>
      				<Icon>
      					<href>'.$icon.'</href>
      				</Icon>
      			</IconStyle>
      			<LabelStyle>
 
      				<scale>'.$labelscale.'</scale>
      			</LabelStyle>
      		</Style>
          <Point>
      			<coordinates>'.$laenge.','.$breite.'</coordinates>
      	  </Point>

      </Placemark>

';

         }
         
   }


// -----------------------------------------------------------------------------
// Keine MySQL-Anmelde-Datei vorhanden
// -----------------------------------------------------------------------------
} else {

   $zoom  = $_GET['zoom'];

   // Ermitteln der zu nutzenden Ordner
   $ldir1 = floor($ldez1);
   $tmp   = floor($ldez2);
   if($tmp == $ldir1) {
      $ldir2 = $tmp;
   } else {
      $ldir2 = ceil($ldez2);
   }
   $ldirs = array();
   for($i=$ldir1;$i<=$ldir2;$i++) {
      $sign   = 'o'; if($i < 0) { $sign = 'w'; }
      $ldirs[] = $sign.intval($i);
   }

   // Ermitteln der zu nutzenden Dateien
   $b2    = floor($bdez2);
   $tmp   = floor($bdez1);
   if($tmp == $b2) {
      $b1 = $tmp;
   } else {
      $b1 = ceil($bdez1);
   }
   $files = array();
   for($i=$b2;$i<=$b1;$i++) {
      $sign   = 'n'; if($i < 0) { $sign = 's'; }
      $files[] = $sign.intval($i).'.csv';
   }

   // Durchlauf aller Verzeichnisse
   foreach($ldirs as $dir) {
      if(!is_dir('kacheln/'.$dir)) { continue; }
      // Durchlauf aller Dateien
      foreach($files as $file) {
         $datei = 'kacheln/'.$dir.'/'.$file;
         if(!is_file($datei)) { continue; }
         
         // Auslesen der Datei und CSV-Ausgabe erstellen
         $daten = file($datei);
         foreach($daten as $nr => $zeile) {
            if($nr == 0) { continue; }
            $scale=0.5;
            $labelscale=0.5;
            $dat = explode("\t",$zeile); 

            // Nur nehmen wenn im sichtbaren Bereich
            if($dat[1] >= $ldez1 AND $dat[1] <= $ldez2 AND
               $dat[2] >= $bdez2 AND $dat[2] <= $bdez1  ) {

            if ($dat[4] <= $zzz){
            
               // Prüfen ob ein Bild mit Namen existiert, dann diese nehmen
               $yd = ''; if(trim($dat[8]) == 'y') { $yd = '-yd'; }

               $textbild = 'iconnamen'.$yd.'/'.$dat[0].'.png';
               if(is_file($textbild) and $dat[3] != 116) {
                   $icon = $textbild;
                  //$scale=4;
                  //if ($zzz==2){$scale=3;}
		              //$scale=4/$zzz;
              $imgsize = getimagesize($textbild);
               $size  = $imgsize[0].','.$imgsize[1]."\t";
               $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
                  
                  
		           $scale=$size/60*$zzz;
               } else {
                  $icon = 'icons'.$yd.'/'.$dat[3].'.png';
               }
               
               // Tiefenangaben sollen nicht angezeigt werden
               if(($dat[3] == '116') or ($dat[3] == '122')){
                  $icon = 'icons/blue-dot.png';
                  $size=0;
                  $labelscale=0.5;
                
              }

              //Label nur text (115) anzeigen
              if($dat['3'] == '115'){
                 //$icon = 'http://www.freietonne.de/ft_icons/png/blue-dot.png';
                 $icon='';
                 $size=0;
                 $labelscale=0.6;
              }

            
            }else{
                $icon = 'icons/blue-dot.png';
                $labelscale=0.5;
            }
 
 
    
            //region
            $north=$dat[2]+0.025;
            $south=$dat[2]-0.025;
            $east=$dat[1]+0.025;
            $west=$dat[1]-0.025;

            $name = htmlspecialchars($dat[5]);
            $beschreibung = htmlspecialchars($dat[6]);
                          
            $KMLFILE .='
      <Placemark>
      	 <name>'.$name.'</name>
      	 <description><![CDATA[<center>Breite: '.$dat[2].'<br />L&auml;nge: '.$dat[1].'<br />
         <br />
         <a href="http://www.freietonne.de/index.php?site=38&infotyp=1&editgps='.$dat[0].'">Bearbeiten</a>
         <a href="http://www.freietonne.de/index.php?site=38&infotyp=1&delgps='.$dat[0].'">L&ouml;schen</a>
         <br>FT-ID: '.$dat[0].'</center>]]><br />'.$beschreibung.'</description>
      	
      		<Style>
      			<IconStyle>
      				<scale>'.$scale.'</scale>
      				<Icon>
      					<href>'.$icon.'</href>
      				</Icon>
      			</IconStyle>
      			<LabelStyle>
      				<scale>' . $labelscale . '</scale>
      			</LabelStyle>
      		</Style>
          <Point>
      			<coordinates>'.$dat[1].','.$dat[2].'</coordinates>
      	  </Point>

      </Placemark>

';
               
            }
         }
      }
   }
}


$KMLFILE .='
</Document>
</kml>';



header("Content-Type: text/plain; charset=utf-8");
//echo 'lat'."\t".'lon'."\t".'title'."\t".'description'."\t".'iconSize'."\t".'iconOffset'."\t".'icon'."\r\n";

echo $KMLFILE;
//echo "\r\n".$sql;
//echo "\r\n".$OP_CSV."\r\n";
?>

