<?PHP

// -----------------------------------------------------------------------------
// Zusammenstellung von POIS für OpenLayer
// -----------------------------------------------------------------------------
//
// Dem Programm wird eine Fläche (in Form von 2 Eckpunkten in Geo-Koordinaten
// (dezimal)) übergeben, und sucht entsprechende Positionen aus der FreienTonne
// heraus, welche sich in diesem Bereich befinden.
//
// Als Quelle wird hierbei entweder die Datenbank der FreienTonne genutzt,
// oder wenn Sie das OSM extern bzw. offline nutzen, eine Quelldatei mit
// allen aktiven Positionen der FreienTonne "ft_osm_pois.csv".
// Diese muss sich im gleichem Verzeichnis wie dieses Script befinden.
//
// Das Programm gibt eine CSV-Datei zurück, in dem sich alle gefundenen
// Positionen befinden. Diese entspricht den Vorlagen von OpenLayer
// für die Klasse "OpenLayers.Layer.Text" (9 Jan 2009)
//
// -----------------------------------------------------------------------------
// Konfiguration
// -----------------------------------------------------------------------------
//
// Die Anzeigenhoehen sind hardcodiert!!
// Bei der FreieTonne existieren 3 Anzeigenhöhen für die Positionen
// 1 = Immer sichtbar
// 2 = Ab großer Höhe sichtbar
// 3 = Ab niedriger Höhe sichtbar
// -----------------------------------------------------------------------------

// MySQL-Server Anmelde-Datei
$mysql = '../admin/_cfg.php';
$OP_CSV = '';


   function dez2grad($dez) {
      if(is_numeric($dez)) {
         $dez = abs($dez);

         $grad  = (int) $dez;
         $temp1 = ($dez - $grad) * 60;
         $min   = (int) $temp1;
         $temp2 = ($temp1 - $min) * 60;
         $sek   = round( $temp2 ,2);

         if($sek >= 60) { $min++; $sek = 0; }
         if($min >= 60) { $grad++; $min = 0; }

         $out = array($grad,$min,$sek);
      } else {
         $out = array('','','');
      }
      return $out;
   }

// -----------------------------------------------------------------------------
// Datei vorhanden = Daten von freietonne.de DB beziehen
// -----------------------------------------------------------------------------
if(is_file($mysql)) {

   include($mysql);

   if(isset($_GET['bdez1']) AND is_numeric($_GET['bdez1']) AND
      isset($_GET['bdez2']) AND is_numeric($_GET['bdez2']) AND
      isset($_GET['ldez1']) AND is_numeric($_GET['ldez1']) AND
      isset($_GET['ldez2']) AND is_numeric($_GET['ldez2']) AND
      isset($_GET['zoom'])  AND is_numeric($_GET['zoom'])) {

      $ldez1 = $_GET['ldez1'];
      $ldez2 = $_GET['ldez2'];
      $bdez1 = $_GET['bdez1'];
      $bdez2 = $_GET['bdez2'];
      $zoom  = $_GET['zoom'];

      $anzeigenhoehe = 'AND anzeigenhoehe = 1';
      if($zoom >= 9) {
         $anzeigenhoehe = 'AND (anzeigenhoehe = 1 OR anzeigenhoehe = 2)'; }
      if($zoom >= 13) {
         $anzeigenhoehe = ''; }


      $sql  = "SELECT * FROM mod_gps WHERE deleted != 'y' AND \r\n";
      $sql .= "(ldez + 0) > '$ldez1' AND (ldez + 0) < '$ldez2' AND \r\n";
      $sql .= "(bdez + 0) > '$bdez2' AND (bdez + 0) < '$bdez1' \r\n";
      $sql .= $anzeigenhoehe;

      $res_csv = mysql_query($sql) or die(mysql_error());
      if(mysql_num_rows($res_csv)) {

         while($dat_csv = mysql_fetch_assoc($res_csv)) {

            // Prüfen ob ein Bild mit Namen existiert, dann diese nehmen
            $yd = ''; if($dat_csv['show_beschreibung'] == 'y') { $yd = '-yd'; }
            $textbild = 'iconnamen'.$yd.'/'.$dat_csv['id'].'.png';
            if(is_file($textbild)) {
               $imgsize = getimagesize($textbild);
               $size  = $imgsize[0].','.$imgsize[1]."\t";
               $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
               // $size .= '0,0';
               $icon = $textbild;
            } else {
               $size = '10,10'."\t".'-5,-5';
               if($zoom >= 15) { $size = '14,14'."\t".'-7,-7'; }
               if($dat_csv['anzeigenhoehe'] == '1' OR $dat_csv['anzeigenhoehe'] == '2') { $size = '16,16'."\t".'-8,-8'; }
               $icon = 'icons'.$yd.'/'.$dat_csv['icon'].'.png';
            }

            // Koordinaten & Name
            $OP_CSV .= $dat_csv['bdez']."\t";
            $OP_CSV .= $dat_csv['ldez']."\t";
            $OP_CSV .= '<span style="font-size:12px;">'.$dat_csv['name'].'</span>'."\t";

            // Gradumrechnung
            // TODO

            // Beschreibung - Popup
            $replace = array("\r\n","\r","\n"); $with = array(' ',' ',' ');
            $OP_CSV .= '<span style="font-size:8px;">'.$dat_csv['bdez'].','.$dat_csv['ldez'].'<br /><br /></span>';
            $OP_CSV .= '<span style="font-size:12px;"><a href="#" style="text-decoration:none;" ';
            $OP_CSV .= 'onclick="window.open(\'http://www.freietonne.de/index.php?site=38&infotyp=1&editgps='.$dat_csv['id'].'\',\'FreieTonne\',\'width=800,height=480,menubar=no,scrollbars=yes\');">';
            $OP_CSV .= 'Bearbeiten</a> ('.$dat_csv['id'].')';
            $OP_CSV .= '<br /><br />'.str_replace($replace,$with,$dat_csv['beschreibung']).'</span>'."\t";

            // Größen & Icons
            $OP_CSV .= $size."\t";
            $OP_CSV .= $icon."\r\n";

         }
      } else {
         $OP_CSV = 'no result';
      }
   }


// -----------------------------------------------------------------------------
// Keine MySQL-Anmelde-Datei vorhanden
// -----------------------------------------------------------------------------
} else {

   if(!is_file('ft_osm_pois.csv')) { header("Content-Type: text/plain; charset=utf-8"); exit; }
   $csv = file('ft_osm_pois.csv');

   $ldez = array();
   $bdez = array();
   $pois = array();

   foreach($csv as $line => $pos) {
      if($line != 0) {
         $dat = explode("\t",$pos);
         if(count($dat) > 2) {
            $ldez[$dat[0]] = $dat[1];
            $bdez[$dat[0]] = $dat[2];
            $pois[$dat[0]] = array(
               'id'            => $dat[0],
               'icon'          => $dat[3],
               'anzeigenhoehe' => $dat[4],
               'name'          => $dat[5],
               'beschreibung'  => trim($dat[6]),
               'show_beschreibung' => trim($dat[8])
            );
         }
      }
   }
   
   // Erstellen der Suchparameter
   $ldez1 = $_GET['ldez1'];
   $ldez2 = $_GET['ldez2'];
   $bdez1 = $_GET['bdez1'];
   $bdez2 = $_GET['bdez2'];
   $zoom  = $_GET['zoom'];

   // Alle Pois mit gegebenen Suchparametern in Ergebnis-Array Ausgeben
   $ergebnis = array();
   
   foreach($ldez as $icon => $dez) {
      if($dez > $ldez1 AND $dez < $ldez2) {
         if($bdez[$icon] > $bdez2 AND $bdez[$icon] < $bdez1) {
            if($zoom >= 13) {
               $ergebnis[] = $icon;
            } elseif($zoom >= 10) {
               if($pois[$icon]['anzeigenhoehe'] == 1 OR $pois[$icon]['anzeigenhoehe'] == 2) {
                  $ergebnis[] = $icon;
               }
            } else {
               if($pois[$icon]['anzeigenhoehe'] == 1) {
                  $ergebnis[] = $icon;
               }
            }
         }
      }
   }

   // Wenn Ergebnisse als CSV für OL zusammenstellen
   if(count($ergebnis)) {
      foreach($ergebnis as $hit) {


         // Prüfen ob ein Bild mit Namen existiert, dann diese nehmen
         $yd = ''; if($pois[$hit]['show_beschreibung'] == 'y') { $yd = '-yd'; }
         $textbild = 'iconnamen'.$yd.'/'.$hit.'.png';
         if(is_file($textbild)) {
            $imgsize = getimagesize($textbild);
            $size  = $imgsize[0].','.$imgsize[1]."\t";
            $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
            // $size .= '0,0';
            $icon = $textbild;
         } else {
            $size = '10,10'."\t".'-5,-5';
            if($zoom >= 15) { $size = '14,14'."\t".'-7,-7'; }
            if($pois[$hit]['anzeigenhoehe'] == 1 OR $pois[$hit]['anzeigenhoehe'] == 2) { $size = '16,16'."\t".'-8,-8'; }
            $icon = 'icons'.$yd.'/'.$pois[$hit]['icon'].'.png';
         }


         // Koordinaten & Name
         $OP_CSV .= $bdez[$hit]."\t";
         $OP_CSV .= $ldez[$hit]."\t";
         $OP_CSV .= '<span style="font-size:12px;">'.$pois[$hit]['name'].'</span>'."\t";

         // Beschreibung - Popup
         $OP_CSV .= '<span style="font-size:8px;">'.$bdez[$hit].','.$ldez[$hit].'<br /><br /></span>';
         $OP_CSV .= '<span style="font-size:12px;">';
         $OP_CSV .= '<a href="#" style="text-decoration:none;" ';
         $OP_CSV .= 'onclick="window.open(\'http://www.freietonne.de/index.php?site=38&infotyp=1&editgps='.$hit.'\',\'FreieTonne\',\'width=800,height=480,menubar=no,scrollbars=yes\');">';
         $OP_CSV .= 'Online Bearbeiten</a> ('.$hit.')<span style="font-size:10px;"><br />Änderung erst nach Update sichtbar<br /></span><br />';
         $OP_CSV .= $pois[$hit]['beschreibung'].'</span>'."\t";

         // Größen & Icons
         $OP_CSV .= $size."\t";
         $OP_CSV .= $icon."\r\n";
      }
   }
}


// -----------------------------------------------------------------------------
// Anzeigen eines Vorschau Icons
// -----------------------------------------------------------------------------
if(isset($_GET['vorschauicon'])) {
   $vi_daten = explode('-',$_GET['vorschauicon']);
   $OP_CSV .= $vi_daten[1]."\t";
   $OP_CSV .= $vi_daten[0]."\t";
   $OP_CSV .= '<span style="font-size:12px;">FT-Position</span>'."\t";
   $OP_CSV .= '<span style="font-size:12px;">Hinweis oder Vorschau einer Position für die FreieTonne.<br /><br /><a href="#" onclick="killVorschauicon();">Ausschalten</a></span>'."\t";
   $OP_CSV .= '37,38'."\t";
   $OP_CSV .= '-18,-19'."\t";
   $OP_CSV .= 'ft-vorschau.png'."\r\n";
}
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Anzeigen Bildschirmmitte (Kursverfolgung)
// -----------------------------------------------------------------------------
if(isset($_GET['centericon'])) {

   $vi_daten2 = explode('-',$_GET['centericon']);

   if(is_file($mysql)) {
      $url = 'http://www.freietonne.de/index.php?site=38&infotyp=1&newgps=1&bdez='.$vi_daten2[1].'&ldez='.$vi_daten2[0];
   } else {
      $url = 'ft-editpois.php?newgps=1&bdez='.$vi_daten2[1].'&ldez='.$vi_daten2[0];
   }

   $OP_CSV .= $vi_daten2[1]."\t";
   $OP_CSV .= $vi_daten2[0]."\t";

   $OP_CSV .= '<span style="font-size:12px;">Ihre GPS-Position</span>'."\t";
   $OP_CSV .= '<span style="font-size:12px;">';
   $OP_CSV .= '<a href="#" onclick="window.open(\''.$url.'\',\'FreieTonne\',\'width=640,height=480,menubar=no,scrollbars=yes\');">Neue FT-Position hier erstellen</a>';
   $OP_CSV .= '<br /><br />Position wird alle 10 Sekunden aktualisiert. Daten werden der Datei "kursverlauf.gps" entnommen.';
   $OP_CSV .= '</span>'."\t";

   $OP_CSV .= '31,31'."\t";
   $OP_CSV .= '-15,-15'."\t";
   $OP_CSV .= 'ft-center.png'."\r\n";
}
// -----------------------------------------------------------------------------



header("Content-Type: text/plain; charset=utf-8");
echo 'lat'."\t".'lon'."\t".'title'."\t".'description'."\t".'iconSize'."\t".'iconOffset'."\t".'icon'."\r\n";
echo $OP_CSV;
// echo "\r\n".$sql;
?>
