<?PHP

// -----------------------------------------------------------------------------
// Zusammenstellung von POIS für OpenLayer
// -----------------------------------------------------------------------------
//
// Dem Programm wird eine Fläche (in Form von 2 Eckpunkten in Geo-Koordinaten
// (dezimal)) übergeben, und sucht entsprechende Positionen aus der FreienTonne
// heraus, welche sich in diesem Bereich befinden.
//
// Als Quelle wird hierbei entweder die Datenbank der FreienTonne genutzt,
// oder wenn Sie das OSM extern bzw. offline nutzen, eine Quelldatei mit
// allen aktiven Positionen der FreienTonne "ft_osm_pois.csv".
// Diese muss sich im gleichem Verzeichnis wie dieses Script befinden.
//
// Das Programm gibt eine CSV-Datei zurück, in dem sich alle gefundenen
// Positionen befinden. Diese entspricht den Vorlagen von OpenLayer
// für die Klasse "OpenLayers.Layer.Text" (9 Jan 2009)
//
// -----------------------------------------------------------------------------
// Konfiguration
// -----------------------------------------------------------------------------
//
// Die Anzeigenhoehen sind hardcodiert!!
// Bei der FreieTonne existieren 3 Anzeigenhöhen für die Positionen
// 1 = Immer sichtbar
// 2 = Ab großer Höhe sichtbar
// 3 = Ab niedriger Höhe sichtbar
// -----------------------------------------------------------------------------

////////////////////////////////////////////////////////////////
//
// Sind wir online oder offline?
// (ACHTUNG EDITMODUS ist nicht EDITMODE!!!)
//
$ip = "www.freietonne.de"; // Change to your server's IP external or domain name
$port = "80"; // Make sure this port is open on the router or firewall

$output = @fsockopen("$ip", $port, $errno, $errstr, 2);
//stream_set_timeout($output, 2);

if (!$output) {
    $EDITMODUS='(mail)';
} else {
    $EDITMODUS='';
}
@fclose($output);
////////////////////////////////////////////////////////////////


$maxiconanzahl = 350;
$maxzoomlevel = 6;
$pixel =20;

if (isset($_GET['EDITMODE'])) {
	$EDITMODE = $_GET['EDITMODE'];
}else{
	$EDITMODE = 'false';
}


$zoom  = $_GET['zoom'];
if ($zoom < $maxzoomlevel) {exit;}

//if ($zoom < 10) {$maxiconanzahl = $maxiconanzahl*2/3;}

// MySQL-Server Anmelde-Datei
$mysql = '../admin/_cfg.php';

$OP_CSV = '';
$OP_CSV_3 = '';
$OP_CSV_2 = '';
$OP_CSV_1 = '';
$OP_CSV_DOT_3 = '';
$OP_CSV_DOT_2 = '';
$anzahl_3=0;
$anzahl_1=0;
$anzahl_2=0;

function dez2grad($dez) {
      if(is_numeric($dez)) {
         $dez = abs($dez);

         $grad  = (int) $dez;
         $temp1 = ($dez - $grad) * 60;
         $min   = (int) $temp1;
         $temp2 = ($temp1 - $min) * 60;
         $sek   = round( $temp2 ,2);

         if($sek >= 60) { $min++; $sek = 0; }
         if($min >= 60) { $grad++; $min = 0; }

         $out = array($grad,$min,$sek);
      } else {
         $out = array('','','');
      }
      return $out;
   }


// -----------------------------------------------------------------------------
// Datei vorhanden = Daten von freietonne.de DB beziehen
// -----------------------------------------------------------------------------
if(is_file($mysql)&&@is_dir('/var/www/freietonne/seekarte/')) {

   include($mysql);

   if(isset($_GET['bdez1']) AND is_numeric($_GET['bdez1']) AND
      isset($_GET['bdez2']) AND is_numeric($_GET['bdez2']) AND
      isset($_GET['ldez1']) AND is_numeric($_GET['ldez1']) AND
      isset($_GET['ldez2']) AND is_numeric($_GET['ldez2']) AND
      isset($_GET['zoom'])  AND is_numeric($_GET['zoom'])) {

      $ldez1 = $_GET['ldez1'];
      $ldez2 = $_GET['ldez2'];
      $bdez1 = $_GET['bdez1'];
      $bdez2 = $_GET['bdez2'];
      $zoom  = $_GET['zoom'];



      if ($EDITMODE=='true'){
          $sql  = "SELECT * FROM mod_gps WHERE deleted != 'y' AND \r\n";
      }else{
          $sql  = "SELECT * FROM mod_gps WHERE deleted != 'y' AND icon <> 42 AND \r\n";
      }
      $sql .= "(ldez + 0) > '$ldez1' AND (ldez + 0) < '$ldez2' AND \r\n";
      $sql .= "(bdez + 0) > '$bdez2' AND (bdez + 0) < '$bdez1' \r\n";

      $res_csv = mysql_query($sql) or die(mysql_error());
      if(mysql_num_rows($res_csv)) {

         while($dat_csv = mysql_fetch_assoc($res_csv)) {

            // Gewässertiefe erst ab Zoom 13 anzeigen
            if ($dat_csv['icon'] == 116 AND $zoom <= 13){
                continue;
            }

            $OP_CSV_DOT = round($dat_csv['bdez'],6)."\t";
            $OP_CSV_DOT .= round($dat_csv['ldez'],6)."\t";
            $OP_CSV_DOT .= "\t";
            $OP_CSV_DOT .= "\t";
            $OP_CSV_DOT .= $pixel.",".$pixel."\t".round(-$pixel/2).",".round(-$pixel/2)."\t";
            $OP_CSV_DOT .= "dot.png"."\r\n";

            
            // Prüfen ob ein Bild mit Namen existiert, dann diese nehmen
            $yd = ''; if($dat_csv['show_beschreibung'] == 'y') { $yd = '-yd'; }
            $textbild = 'iconnamen'.$yd.'/'.$dat_csv['id'].'.png';
            if(is_file($textbild)) {
               $imgsize = getimagesize($textbild);
               $size  = $imgsize[0].','.$imgsize[1]."\t";
               $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
               // $size .= '0,0';
               $icon = $textbild;
            } else {
               $size = $pixel.",".$pixel."\t".round(-$pixel/2).",".round(    -$pixel/2); 
               $icon = 'icons'.$yd.'/'.$dat_csv['icon'].'.png';
            }

           // MJ 6.5.2014 wieder hinzu programmiert
           // Gewässertiefe
           if($icon == 'icons/116.png') {
               // Wenn Erstellung OK war, existiert ein eigenes Icon
               $ticon = '../ft_icons/png-namen/'.$dat_csv['id'].'.png';
               if(is_file($ticon)) {
                  // Icon wird übernommen, und die Größe für die Ausgabe geändert
                  $icon = $ticon;
                  $imgsize = getimagesize($icon);
                  $size  = $imgsize[0].','.$imgsize[1]."\t";
                  $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
               }
           }
            
   	     if ($icon == 'icons/34.png'){
                $txttmp = preg_replace('/,/', '.', $dat_csv['name']);
		          $txttmp = $txttmp*1000;
                $txt = preg_replace("/[^\d]/iU",'',$txttmp);
		            $txt = $txt/1000;

                if (strlen($txt) == 1){
                   $txt=$txt.'.0';
                }
		            $txt=intval($txt*10)/10;

		            if (($txt <> '')){
                  $icon = 'png-tiefe/Tiefe-'.$txt.'.png';
                  if(is_file($icon)) {
                     $imgsize = getimagesize($icon);
                     $size  = $imgsize[0].','.$imgsize[1]."\t";
                     $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
                  }else{
                     $icon = 'icons/34.png';
                  }
                }

	        }

   	     if (($icon == 'icons/33.png')or($icon == 'icons/350.png')){
                $txttmp = preg_replace('/,/', '.', $dat_csv['name']);
		            $txttmp = $txttmp*1000;
                $txt = preg_replace("/[^\d]/iU",'',$txttmp);
		            $txt = $txt/1000;

                if (strlen($txt) == 1){
                   $txt=$txt.'.0';
                }
		
		            $txt=intval($txt*10)/10;
            		if (( $txt < 3.5 ) and ($txt > 1.5)) {
            			$dat_csv['anzeigenhoehe'] = 2;
            		}

		            if (($txt <> '')){
                  $icon = 'png-oben/oben-'.$txt.'.png';
                  if(is_file($icon)) {
                     $imgsize = getimagesize($icon);
                     $size  = $imgsize[0].','.$imgsize[1]."\t";
                     $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
                  }else{
                     $icon = 'icons/33.png';
                  }
                }

   	     }

	     if ($icon == 'icons/122.png'){
      		$dat_csv['anzeigenhoehe'] = 1;
      		$txttmp =  preg_replace('/,/', '.', $dat_csv['name']);
      		$txtexplode = explode(".",$txttmp);
      		$txt = $txtexplode[0];
          $txt = preg_replace("/[^\d]/iU",'',$txt);

          if (($zoom<14) and ($zoom>=12) and ($txt/2 <> intval($txt/2))){
                  $txt='';
          }else if (($zoom<12) and (($txt/5) <> intval($txt/5))){
                  $txt='';
          }

      		if (($txt <> '')){
                  $icon = 'png-km/km_'.$txt.'.png';
                  if(is_file($icon)) {
                     $imgsize = getimagesize($icon);
                     $size  = $imgsize[0].','.$imgsize[1]."\t";
                     $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
                  }
                }else{
                     $icon = 'icons/122.png';
                }

    	     }

            if (($zoom<10)and($icon=='icons/122.png')){
                continue;
            }
            // Koordinaten
            $OP_CSV = round($dat_csv['bdez'],6)."\t";
            $OP_CSV .= round($dat_csv['ldez'],6)."\t";
            
            //if ($zoom > $maxzoomlevel + 2){
            // Name
            $link1 = $linkstyle = '';
            if($dat_csv['name']) {
              if (($EDITMODUS<>'(mail)')&&(substr($dat_csv['name'],-2)<>' m')&&(!is_numeric ($dat_csv['name']))  && (!strpos($dat_csv['name'], 'km '))){

               //$nameurl='http://www.google.de#q=' . $dat_csv['name'] ;
               $nameurl='http://www.google.de/cse?cx=partner-pub-9440321815762949:1121947455&ie=UTF-8&q=' . $dat_csv['name'] ;
               //$link1 = ' onclick="window.open(\''.str_replace(' ','%20',$nameurl).'\',\'ExternerLink\',\'width=800,height=600,menubar=yes,scrollbars=yes\');"';
               $link1 = ' onclick="exlink_edit(\'' . str_replace(' ','%20',$nameurl). '\');"';
               $linkstyle = 'color:blue;';
              }
            }
            
            if($dat_csv['link']) {
               //$link1 = ' onclick="window.open(\''.str_replace(' ','%20',$dat_csv['link']).'\',\'ExternerLink\',\'width=800,height=600,menubar=yes,scrollbars=yes\');"';
               $link1 = ' onclick="exlink_edit(\'' . str_replace(' ','%20',$dat_csv['link']). '\');"';
               $linkstyle = 'color:blue;';
            }
            $OP_CSV .= '<span style="font-size:12px;'.$linkstyle.'"'.$link1.'>'.$dat_csv['name'].'</span>'."\t";

            // Gradumrechnung
            // TODO

            // Beschreibung - Popup
            $replace = array("\r\n","\r","\n"); $with = array(' ',' ',' ');



               // Beschreibung - Popup
               $OP_CSV .= '<p style="font-size:10px;">';
               $OP_CSV .= '<a href="#" style="text-decoration:none;" ';
               $OP_CSV .= 'onclick="poi_history(' . $dat_csv['osmid']. ');">';
               $OP_CSV .= 'Lat: '.substr($dat_csv['bdez'],0,8).', Lon: '.substr($dat_csv['ldez'],0,8);
               $OP_CSV .= '<br />OSM-ID: '.$dat_csv['osmid'].'</a></p>';

               if ($zoom > 13) {

                    $OP_CSV .= '<p style="font-size:10px;"><a href="#" style="text-decoration:none;" ';
                    $OP_CSV .= 'onclick="poi_change(' . $dat_csv['id']. ');">';
                    $OP_CSV .= '<br />Ändern: '.$dat_csv['id'].'</a>';
                    $OP_CSV .= '<a href="#" style="text-decoration:none;" ';
                    $OP_CSV .= 'onclick="poi_position_change_buttons(' . $dat_csv['id']. ');">';
                    $OP_CSV .= '<br />Verschieben: '.$dat_csv['id'].'</a>';
                    $OP_CSV .= '<a href="#" style="text-decoration:none;" ';
                    $OP_CSV .= 'onclick="poi_delete(' . $dat_csv['id']. ');">';
                    $OP_CSV .= '<br />Löschen: '.$dat_csv['id'].'</a></p>';

               }
               $OP_CSV .= '<p style="font-size:12px;">'. str_replace($replace,$with,$dat_csv['beschreibung']).'</p>'."\t";

              // Größen & Icons
            $OP_CSV .= $size."\t";
            $OP_CSV .= $icon."\r\n";

            //$OP_CSV_1 .= $OP_CSV;
                        // Anzeigenhöhe  Poi-Schichten zuordnen


	    if (($icon <> 'icons/350.png')or($EDITMODE == 'true')){
            if($dat_csv['anzeigenhoehe'] == 3) {
               //if (($zoom > 9) and ($zoom < 15) and ($anzahl_3 < $maxiconanzahl) and ((round($anzahl_3)/4)==($anzahl_3/4))){
               //if (($zoom > 10) and ($zoom < 15)){
               //No Caravan  und auch keine Tiefenangaben in der Uebersicht
               if (($icon <> 'icons/344.png')and($dat_csv['icon'] <> 116)){
                  $OP_CSV_DOT_3 .= $OP_CSV_DOT;
               }
               $OP_CSV_3 .= $OP_CSV;

               $anzahl_3 = $anzahl_3+1;
            }
            if($dat_csv['anzeigenhoehe'] == 2) {
               $OP_CSV_2 .= $OP_CSV;
               $OP_CSV_DOT_2 .= $OP_CSV_DOT;
               $anzahl_2 = $anzahl_2+1;
            }
            if($dat_csv['anzeigenhoehe'] == 1) {
               $OP_CSV_1 .= $OP_CSV;
               //$OP_CSV_DOT_1 .= $OP_CSV_DOT;
               $anzahl_1 = $anzahl_1+1;
            }
	    }
         }
      }
   }


// -----------------------------------------------------------------------------
// Keine MySQL-Anmelde-Datei vorhanden
// -----------------------------------------------------------------------------
} else {

   // Erstellen der Suchparameter
   $ldez1 = $_GET['ldez1'];
   $ldez2 = $_GET['ldez2'];
   $bdez1 = $_GET['bdez1'];
   $bdez2 = $_GET['bdez2'];
   $zoom  = $_GET['zoom'];

   // Ermitteln der zu nutzenden Ordner
   $ldir1 = floor($ldez1);
   $tmp   = floor($ldez2);
   if($tmp == $ldir1) {
      $ldir2 = $tmp;
   } else {
      $ldir2 = ceil($ldez2);
   }
   $ldirs = array();
   for($i=$ldir1;$i<=$ldir2;$i++) {
      $sign   = 'o'; if($i < 0) { $sign = 'w'; }
      $ldirs[] = $sign.intval($i);
   }

   // Ermitteln der zu nutzenden Dateien
   $b2    = floor($bdez2);
   $tmp   = floor($bdez1);
   if($tmp == $b2) {
      $b1 = $tmp;
   } else {
      $b1 = ceil($bdez1);
   }
   $files = array();
   for($i=$b2;$i<=$b1;$i++) {
      $sign   = 'n'; if($i < 0) { $sign = 's'; }
      $files[] = $sign.intval($i).'.csv';
   }

   // echo '<pre>'.print_r($ldirs,1).'</pre>';
   // echo '<pre>'.print_r($files,1).'</pre>';

   // Durchlauf aller Verzeichnisse
   foreach($ldirs as $dir) {
      if(!is_dir('kacheln/'.$dir)) { continue; }
      // Durchlauf aller Dateien
      foreach($files as $file) {
         $datei = 'kacheln/'.$dir.'/'.$file;
         if(!is_file($datei)) { continue; }
         
         // Auslesen der Datei und CSV-Ausgabe erstellen
         $daten = file($datei);
         foreach($daten as $nr => $zeile) {
            if($nr == 0) { continue; }
            
            $dat = explode("\t",$zeile);
            
            // Nur nehmen wenn im sichtbaren Bereich
  	    if($dat[1] >= $ldez1 AND $dat[1] <= $ldez2 AND
  	       $dat[2] >= $bdez2 AND $dat[2] <= $bdez1) {

	       if ($EDITMODE!='true' AND $dat[3]==42){
	         continue;
	       }
	       
	       // Gewässertiefe erst ab Zoom 13 anzeigen
	       if ($dat[3] == 116 AND $zoom <= 13){
	           continue;
	       }
	       
	       
	       
	       
	       
               // Prüfen ob ein Bild mit Namen existiert, dann diese nehmen
               $yd = ''; if(trim($dat[8]) == 'y') { $yd = '-yd'; }
               $textbild = 'iconnamen'.$yd.'/'.$dat[0].'.png';
               if(is_file($textbild)) {
                  $imgsize = getimagesize($textbild);
                  $size  = $imgsize[0].','.$imgsize[1]."\t";
                  $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
                  $icon = $textbild;
               } else {
                  $size = $pixel.",".$pixel."\t".round(-$pixel/2).",".round(-$pixel/2);
                  //if($zoom > 14) { $size = '15,15'."\t".'-7,-7'; }
                  //if($dat[4] == 1 OR $dat[4] == 2) { $size = $pixel.",".$pixel."\t".round(-$pixel/2).",".round(-$pixel/2); }
                  $icon = 'icons'.$yd.'/'.$dat[3].'.png';
               }
               

	     if ($icon == 'icons/34.png'){
                $txttmp = preg_replace('/,/', '.', $dat['5']);
		            $txttmp = $txttmp*1000;
                $txt = preg_replace("/[^\d]/iU",'',$txttmp);
		            $txt = $txt/1000;

                if (strlen($txt) == 1){
                   $txt=$txt.'.0';
                }
		$txt=intval($txt*10)/10;

		            if (($txt <> '')){
                  $icon = 'png-tiefe/Tiefe-'.$txt.'.png';
                  if(is_file($icon)) {
                     $imgsize = getimagesize($icon);
                     $size  = $imgsize[0].','.$imgsize[1]."\t";
                     $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
                  }else{
                     $icon = 'icons/34.png';
                  }
                }

	     }

	     if (($icon == 'icons/33.png')or($icon == 'icons/350.png')){
                $txttmp = preg_replace('/,/', '.', $dat['5']);
		            $txttmp = $txttmp*1000;
                $txt = preg_replace("/[^\d]/iU",'',$txttmp);
		            $txt = $txt/1000;

                if (strlen($txt) == 1){
                   $txt=$txt.'.0';
                }
		            $txt=intval($txt*10)/10;
                if (( $txt < 3.5 ) and ($txt > 1.5)) {
                        $dat['4'] = 2;
                }

            if (($txt <> '')){
                  $icon = 'png-oben/oben-'.$txt.'.png';
                  if(is_file($icon)) {
                     $imgsize = getimagesize($icon);
                     $size  = $imgsize[0].','.$imgsize[1]."\t";
                     $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
                  }else{
                     $icon = 'icons/33.png';
                  }
                }

	     }

	     if ($icon == 'icons/122.png'){
		            $dat[4] = 1;
                $txttmp =  preg_replace('/,/', '.', $dat['5']);
                $txtexplode = explode(".",$txttmp);
                $txt = $txtexplode[0];
                $txt = preg_replace("/[^\d]/iU",'',$txt);
 
                if (($zoom<14) and ($zoom>=12) and ($txt/2 <> intval($txt/2))){
                        $txt='';
                }else if (($zoom<12) and ($txt/5 <> intval($txt/5))){
                        $txt='';
                }

          		if ($txt <> ''){
                    $icon = 'png-km/km_'.$txt.'.png';
                    if(is_file($icon)) {
                        $imgsize = getimagesize($icon);
                        $size  = $imgsize[0].','.$imgsize[1]."\t";
                        $size .= '-'.ceil(($imgsize[0]/2)).',-'.ceil(($imgsize[1]/2));
                    }else{
                        $icon = 'icons/122.png';
                    }
                }

           }
           if (($zoom<11)and($icon=='icons/122.png')){
                 continue;
           }

               
               // Koordinaten & Name
               $OP_CSV = $dat[2]."\t";
               $OP_CSV .= $dat[1]."\t";

               if (($EDITMODUS<>'(mail)')&&(substr($dat[5],-2)<>' m')&&(!is_numeric ($dat[5]))  && (!strpos($dat[5], 'km '))){
                     $nameurl='http://www.google.de/cse?cx=partner-pub-9440321815762949:1121947455&ie=UTF-8&q=' . $dat[5] ;
                     $link1 = ' onclick="exlink_edit(\'' . str_replace(' ','%20',$nameurl). '\');"';
                     $linkstyle = 'color:blue;';
                     $OP_CSV .= '<span style="font-size:12px;'.$linkstyle.'"'.$link1.'>'.$dat[5].'</span>'."\t";
               }else{
                     $OP_CSV .= '<p style="font-size:12px;">'.$dat[5].'</p>'."\t";
               }




               // Beschreibung - Popup
               $OP_CSV .= '<p style="font-size:10px;">Lat: '.substr($dat[2],0,8).', Lon: '.substr($dat[1],0,8);

               if ($zoom > 13) {
                    //$OP_CSV .= '<span style="font-size:12px;">';
                    //$OP_CSV .= '<a href="#" style="text-decoration:none;" ';
                    //$OP_CSV .= 'onclick="window.open(\'http://www.freietonne.de/index.php?site=38&infotyp=1&editgps='.$dat[0].'\',\'FreieTonne\',\'width=800,height=480,menubar=no,scrollbars=yes\');">';
                    //$OP_CSV .= 'Online Bearbeiten</a> ';

                    $OP_CSV .= '<a href="#" style="text-decoration:none;" ';
                    $OP_CSV .= 'onclick="poi_change(' . $dat[0]. ');">';
                    $OP_CSV .= '<br />Ändern: '.$dat[0].' '.$EDITMODUS.'</a>';
                    $OP_CSV .= '<a href="#" style="text-decoration:none;" ';
                    $OP_CSV .= 'onclick="poi_position_change_buttons(' . $dat[0]. ');">';
                    $OP_CSV .= '<br />Verschieben: '.$dat[0].' '.$EDITMODUS.'</a>';
                    $OP_CSV .= '<a href="#" style="text-decoration:none;" ';
                    $OP_CSV .= 'onclick="poi_delete(' . $dat[0]. ');">';
                    $OP_CSV .= '<br />Löschen: '.$dat[0].' '.$EDITMODUS.'</a></p>';

                    //$OP_CSV .= '<span style="font-size:10px;"><br /><br />Änderung erst nach Update sichtbar<br /></span><br />';
               }
               $OP_CSV .= '<p style="font-size:12px;">'. trim($dat[6]).'</p>'."\t";

               // Größen & Icons
               $OP_CSV .= $size."\t";
               $OP_CSV .= $icon."\r\n";
              
               $OP_CSV_DOT = $dat[2]."\t";
               $OP_CSV_DOT .= $dat[1]."\t";
               $OP_CSV_DOT .= "\t";
               $OP_CSV_DOT .= "\t";
               $OP_CSV_DOT .= "15,15\t" . "-7,-7\t";
               $OP_CSV_DOT .= "dot.png"."\r\n";
                
            // Anzeigenhöhe  Poi-Schichten zuordnen
	       if (($icon <> 'icons/350.png')or($EDITMODE == 'true')){
               if($dat[4] == 3) {
                    //if (($zoom > 9) and ($zoom < 15) and ($anzahl_3 < $maxiconanzahl) and ((round($anzahl_3)/4)==($anzahl_3/4))){
                    //if (($zoom > 10) and ($zoom < 15)){
                    //No Caravan und keine Tiefenangabe in der Uebersicht
                  if (($icon <> 'icons/344.png')and($dat[3]<>116)){
                     $OP_CSV_DOT_3 .= $OP_CSV_DOT;
                  }
                  $OP_CSV_3 .= $OP_CSV;

                  $anzahl_3 = $anzahl_3+1;
               }
               if($dat[4] == 2) {
                    $OP_CSV_2 .= $OP_CSV;
                    $OP_CSV_DOT_2 .= $OP_CSV_DOT;
                    $anzahl_2 = $anzahl_2+1;
               }
               if($dat[4] == 1) {
                    $OP_CSV_1 .= $OP_CSV;
                    //$OP_CSV_DOT_1 .= $OP_CSV_DOT;
                    $anzahl_1 = $anzahl_1+1;
               }
               } 
               
            }
         }
      }
   }
   // echo '<pre>'.print_r($dirs,1).'</pre>';
   // echo '<pre>'.print_r($files,1).'</pre>';
}


// -----------------------------------------------------------------------------
// Anzeigen eines Vorschau Icons
// -----------------------------------------------------------------------------
if(isset($_GET['vorschauicon'])) {
   //$vi_daten = explode('-',$_GET['vorschauicon']);
   //$OP_CSV_1 .= $vi_daten[1]."\t";
   //$OP_CSV_1 .= $vi_daten[0]."\t";
   //$OP_CSV_1 .= '<span style="font-size:12px;">FT-Position</span>'."\t";
   //$OP_CSV_1 .= '<span style="font-size:12px;">Hinweis oder Vorschau einer Position für die FreieTonne.<br /><br /><a href="#" onclick="killVorschauicon();">Ausschalten</a>';

//$OP_CSV_1 .= '<br /></span>'."\t";


   //$OP_CSV_1 .= '37,38'."\t";
   //$OP_CSV_1 .= '-18,-19'."\t";
   //$OP_CSV_1 .= 'ft-vorschau.png'."\r\n";
}
// -----------------------------------------------------------------------------



header("Content-Type: text/plain; charset=utf-8");
echo 'lat'."\t".'lon'."\t".'title'."\t".'description'."\t".'iconSize'."\t".'iconOffset'."\t".'icon'."\r\n";
if (( $anzahl_3+$anzahl_2+$anzahl_1 <  $maxiconanzahl*0.8) and ($zoom > $maxzoomlevel+2)) {
    echo $OP_CSV_3;
} elseif (($zoom >= $maxzoomlevel) and ( $anzahl_3+$anzahl_2+$anzahl_1 < $maxiconanzahl*2.5 )){
    echo $OP_CSV_DOT_3;
}
if (( $anzahl_2+$anzahl_1 < $maxiconanzahl ) and ($zoom > $maxzoomlevel+1)) {
    echo $OP_CSV_2;
}elseif (($zoom >= $maxzoomlevel) and ( $anzahl_2+$anzahl_1 < $maxiconanzahl*2)){
    echo $OP_CSV_DOT_2;
}
//if (($zoom >= $maxzoomlevel ) and ( $anzahl_1 < $maxiconanzahl)) {
if ($zoom > $maxzoomlevel-2 ){
    echo $OP_CSV_1;
}
// echo "\r\n".$sql;
?>
