<?PHP

// -----------------------------------------------------------------------------
// Zusammenstellung von Ways für OpenLayer
// -----------------------------------------------------------------------------
//
// Dem Programm wird eine Fläche (in Form von 2 Eckpunkten in Geo-Koordinaten
// (dezimal)) übergeben, und sucht entsprechende Positionen aus der FreienTonne
// heraus, welche sich in diesem Bereich befinden.
//
// Als Quelle wird hierbei entweder die Datenbank der FreienTonne genutzt,
// oder wenn Sie das OSM extern bzw. offline nutzen, eine Quelldatei mit
// allen aktiven Positionen der FreienTonne "ft_osm_pois.csv".
// Diese muss sich im gleichem Verzeichnis wie dieses Script befinden.
//
// Das Programm gibt eine CSV-Datei zurück, in dem sich alle gefundenen
// Positionen befinden. Diese entspricht den Vorlagen von OpenLayer
// für die Klasse "OpenLayers.Layer.Text" (9 Jan 2009)
//
// -----------------------------------------------------------------------------
// Konfiguration
// -----------------------------------------------------------------------------
//
// Die Anzeigenhoehen sind hardcodiert!!
// Bei der FreieTonne existieren 3 Anzeigenhöhen für die Positionen
// 1 = Immer sichtbar
// 2 = Ab großer Höhe sichtbar
// 3 = Ab niedriger Höhe sichtbar
// -----------------------------------------------------------------------------


// Erstellen der Suchparameter
//if(isset($_GET['ldez1'])){
  $ldez1 = $_GET['ldez1'];
  $ldez2 = $_GET['ldez2'];
  $bdez1 = $_GET['bdez1'];
  $bdez2 = $_GET['bdez2'];
  $zoom  = $_GET['zoom'];
  $layer = $_GET['layer'];

//}else{

//  $ldez1 = 6;
//  $ldez2 = 14.5;
//  $bdez1 = 70;
//  $bdez2 = 20;
//  $zoom  = 12;
//}


//if ($zoom < $maxzoomlevel) {exit;}

$OP_CSV = '';
$OP_CSV_3 = '';
$OP_CSV_2 = '';
$OP_CSV_1 = '';
$OP_CSV_DOT_3 = '';
$OP_CSV_DOT_2 = '';
$anzahl_3=0;
$anzahl_1=0;
$anzahl_2=0;

header("Content-Type: text/plain; charset=utf-8");
print "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\" ?>\n<gpx version=\"1.0\" creator=\"Turbo GPS\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns=\"http://www.topografix.com/GPX/1/0\" xsi:schemaLocation=\"http://www.topografix.com/GPX/1/0 http://www.topografix.com/GPX/1/0/gpx.xsd\">\n";
print "\n<trk>\n";
// -----------------------------------------------------------------------------
// Keine MySQL-Anmelde-Datei vorhanden
// -----------------------------------------------------------------------------

$datei = 'fluesse/' . $layer;
if(!is_file($datei)) { print "Datei nicht gefunden"; }

// Auslesen der Datei und CSV-Ausgabe erstellen
$daten = file($datei);


$track_ein=false;
$trknr=1;
print "  <trkseg>\n    <name>" . $trknr . "</name>\n";

foreach($daten as $nr => $zeile) {
  //if($nr == 0) { continue; }
  
  $zeile=ltrim("$zeile");
  if ((substr($zeile,0,7) != "<trkpt ") && (substr($zeile,0,8) != "<trkseg>")) { continue; }
  
  if (substr($zeile,0,8) == "<trkseg>"){
      //print $zeile;
      $track_ein=true;
      
      if ($trkptnr > 0) {
          $trknr=$trknr+1;
          
          $ausgabe="  </trkseg>\n  <trkseg>\n    <name>" . $trknr . "</name>\n";
          print $ausgabe;
          
      }                
      $trkptnr=0;
  }
  
  
  $zeile=str_replace("<trkpt lat=",'',$zeile);
  $zeile=str_replace("lon=",'',$zeile);
  $zeile=str_replace(">",'',$zeile);
  $zeile=str_replace("\"",'',$zeile);
  $zeile=trim($zeile);

  $dat = explode(' ' ,$zeile);
  //print $dat[0].$dat[1];
  // Nur nehmen wenn im sichtbaren Bereich
  if($dat[1] > $ldez1 AND $dat[1] < $ldez2
     AND $dat[0] > $bdez2 AND $dat[0] < $bdez1) {

     if (($zoom > 8) or ($trkptnr/5 == round($trkptnr/5))){
        $lon=trim($dat[1]);
        $lat=trim($dat[0]);
    
        $track_ein=true;
    
        print "    <trkpt lat=\"" . $lat . "\" lon=\"" . $lon . "\">\n    </trkpt>\n";
    
                 
     }
     $trkptnr=$trkptnr+1;
  }else{
  
      if ($track_ein){
          $track_ein=false;
      }
  }
}

print "  </trkseg>\n  </trk>\n</gpx>\n";

?>
