<?php
/*
 * kursverlauf.php - Abfrage der aktuellen Position von einem GPSD Server auf Port 2947
 * WICHTIG: Das Teil soll keine leere Antwort liefern, sonst schaltet die GPS-Anzeige im template.html ab
 */


// Fuer MacOSX der kurze Weg:
// Position wird durch Script /usr/local/bin/GPS.command ermittelt und in kursverlauf.gps geschrieben.
// kursverlauf.php (dieses script), startet nur GPS.command und liest Position aus kursverlauf.gps
// Dann Ende.
if (is_file("/usr/local/bin/GPS.command")){
        $cmd='ps ax |grep gpsread|grep -v grep >> /dev/null 2>&1; if test "$?" = 1;then sudo /usr/local/bin/GPS.command; else cat kursverlauf.gps;fi';
        system("$cmd");
        exit;
}

//http://gpsd.berlios.de/gpsd.html
//t = Kurs
//v = Speed
//P = Position
//O= kompletter Satz


// TCP Verbindung oeffnen (localhost, port 2947)
$sock = @fsockopen('127.0.0.1', 2947, $errno, $errstr, 2);
//@fwrite($sock, "J=1,W=1\n"); # watcher mode and buffering 

/////////////////////////////////////////////////////////////////////////////
// Schreibe "P" an GPSD, um die aktuelle Position zu erhalten
//@fwrite($sock, "P\n");

$resp="GPSD,P=?,V=?,T=?" ;

// Wir lesen, bis wir eine Position bekommen
// Geschwindigkeit und Kurs sind uns dabei egal

$zzz=1;
//while (( substr($resp,0,9) == "GPSD,P=?," )and ($zzz<4)){
while (($zzz<6) and 
  (!((preg_match('/P=([0-9\.-]+) ([0-9\.-]+)/', $resp, $m)) && 
  (preg_match('/V=([0-9\.-]+),/', $resp, $m))&&
  (preg_match('/T=([0-9\.-]+),/', $resp, $m))))) {
    @fwrite($sock, "PVTQ\r\n");
    sleep(1);
    $resp = @fread($sock, 384);

    if ( substr($resp,0,9) == "GPSD,P=?," ){
        //sleep(1);
    }
		
	  //@fwrite($sock, "PVTQ\r\n");	# Query what we actually want
	  # the O report doesn't give us satellite usage or DOP
	  //$resp = @fread($sock, 384);

    $zzz=$zzz+1;
	  //$resp="GPSD,P=52.431738333 13.572940000,V=20,T=45";
	  //print "$resp\n";

}

// TCP Verbindung schliessen
@fclose($sock);

//$resp=substr($resp,0,length($resp)-1) . ",";        
//print $resp;

// Wenn Position bekannt, dann ausgeben!
if (preg_match('/P=([0-9\.-]+) ([0-9\.-]+)/', $resp, $m)) {
	    // Formatierung der Ausgabe auf 5 Nachkommastellen
	    //printf("%3.5f,%3.5f", $m[2], $m[1]);

      $lon=$m[2];
      $lat=$m[1];
}else{
        //letzte bekannte Position anzeigen
       	// Position PSB24 wenn keine Koordinaten in kursanzeige.gps
        $pos = file_get_contents('kursverlauf.gps');
       	if (strlen($pos)==1) {
       	  $lon=13.572921667;
       	  $lat=53.431711667;
       	  print "$lon,$lat\n";
        }else{
          print "$pos\n";
        }
        
        //Neustart GPS und Fehleranzeige
       	exec('cd \\usr\\gpsd && \\usr\\bin\\perl gpsd-wrapper.pl');
       	
       	
       	//GoogleEarth auf letzte bekannte Position und Draufsicht stellen
        list ($lon,$lat)=split(",",$pos);       
        $resp="GPSD,P=" . $lon . " " . $lat . ",V=0.1,T=0.1,Q=xxx";
  	    //print $resp;
}    

if (preg_match('/V=([0-9\.-]+),/', $resp, $m)){
      $speed=abs($m[1]);
      //print "\n$speed\n";        
}else{
      //exit;
      $speed=0;
}

if (preg_match('/T=([0-9\.-]+),/', $resp, $m)){
      $heading=abs($m[1]);        
      //print "$heading\n";
}

$txt=$lon . ',' . $lat. ',' . $heading. ',' . $speed;
print $txt;

           
//print "\n$resp\n";

////////////////////////////////////////////////////////////////////////////



//print "\nk $heading\n";
//print "v $speed\n";
//print "lat $lat\n";
//print "lon $lon\n";

//$speed=10;
//$heading=180;
//$lat=52;
//$lon=13;

if ($speed < 2){
  $tilt="<tilt>0</tilt>";
  $heading=0;
  $altitude=5000;
  $tacho='';
}else{
  $tilt="<tilt>68</tilt>";
  //$altitude=220;
  $altitude=210;
  $range="<range>1100</range>";
  $tspeed=round($speed*1.875,0);
  $theading=round(($heading/10),0)*10;
  $vfile="http://localhost:85/seekarte/GE-Tacho/" . $tspeed . "kmh.png";
  $hfile="http://localhost:85/seekarte/GE-Tacho/" . $theading . "Grad.png";
  
  $tacho='
  
<ScreenOverlay>
    <name>Geschwindigkeit</name>
    <Icon>
      <href>' . $vfile . '</href>
    </Icon>
    <overlayXY x="0" y="1" xunits="pixels" yunits="pixels"/>
    <screenXY x="115" y="50" xunits="pixels" yunits="pixels"/>
    <rotationXY x="0" y="0" xunits="fraction" yunits="fraction"/>
    <size x="0" y="0" xunits="fraction" yunits="fraction"/>
</ScreenOverlay>

<ScreenOverlay>
    <name>Richtung</name>
    <Icon>
      <href>' . $hfile . '</href>
    </Icon>
    <overlayXY x="0" y="1" xunits="pixels" yunits="pixels"/>
    <screenXY x="115" y="80" xunits="pixels" yunits="pixels"/>
    <rotationXY x="0" y="0" xunits="fraction" yunits="fraction"/>
    <size x="0" y="0" xunits="fraction" yunits="fraction"/>
</ScreenOverlay>

';

}


$handle = fopen("kursverlauf.kml","w");

$kml='<?xml version="1.0" standalone="yes"?>
<kml xmlns="http://earth.google.com/kml/2.0">
<Document>

' . $tacho . '


    <LookAt>
      <longitude>' . $lon . '</longitude>
      <latitude>' . $lat . '</latitude>
      <altitude>' . $altitude . '</altitude>' . $tilt . $range . '
      <altitudeMode>relativeToGround</altitudeMode>
      <heading>' . $heading . '</heading>
    </LookAt>

  <Placemark><name>aktuelle Position:</name>
    <description><![CDATA[<center>Breite: ' . $lat . '<br />L&auml;nge: ' . $lon . '<br />
         <br />
         <a href="http://localhost:85/seekarte/ft-editpois.php?site=38&infotyp=1&newgps=1&bdez=' . $lat . '&ldez=' . $lon . '">Neues Seezeichen</a>
         <br />(Wird nur in Openlayers dargestellt!)<br />]]>
    </description>

    <Style id="default+icon=/usr/local/bin/gps-server.png">
      <IconStyle>
        <scale>1</scale>
        <Icon>
           <href>http://localhost:85/seekarte/ft-center.png</href>
        </Icon>
      </IconStyle>
      <LabelStyle>
        <scale>1</scale>
      </LabelStyle>
      <visibility>1</visibility>
      <open>1</open>
      <LabelStyle><color>0</color></LabelStyle>
      <LineStyle>
        <color>ffffff00</color>
        <width>5</width>
      </LineStyle>
      <PolyStyle><color>aaffff00</color></PolyStyle>
    </Style>

    <Point>
      <coordinates>
        ' . $lon . ',' . $lat . ',600
      </coordinates>
    </Point>
  </Placemark>

</Document>
</kml>
';

fwrite($handle,$kml);

fclose($handle);

$handle = fopen("kursverlauf.gps","w");
$txt=$lon . ',' . $lat. ',' . $heading. ',' . $speed;
fwrite($handle,$txt);
fclose($handle);

?>
                                
