<?php
/*
 * kursverlauf.php - Abfrage der aktuellen Position von einem GPSD Server auf Port 2947
 * WICHTIG: Das Teil soll keine leere Antwort liefern, sonst schaltet die GPS-Anzeige im template.html ab
 */


// Fuer MacOSX der kurze Weg:
// Position wird durch Script /usr/local/bin/GPS.command ermittelt und in kursverlauf.gps geschrieben.
// kursverlauf.php (dieses script), startet nur GPS.command und liest Position aus kursverlauf.gps
// Dann Ende.
if (is_file("/usr/local/bin/GPS.command")){
        $cmd='ps ax |grep gpsread|grep -v grep >> /dev/null 2>&1; if test "$?" = 1;then sudo /usr/local/bin/GPS.command; else cat kursverlauf.gps;fi';
        system("$cmd");
        exit;
}

if (filemtime('kursverlauf.gps')<time()-40){
  touch('kursverlauf.gps');
  if (is_file('/usr/nc-gpsd/startCatNc.cmd')){
	system("cd \\usr\\nc-gpsd && start /min startCatNc.cmd");
  }
  if (is_file('/usr/local/bin/gpsStart')){
	system("sudo /usr/local/bin/gpsStart 2>&1 &");
	//system("sudo /usr/bin/xterm -display :0 -e /usr/local/bin/gpsStart");
	
  }
}

$file = file('kursverlauf.gps');

foreach ($file as $pos) {
  list($lon,$lat,$heading,$speed) = explode(",",$pos);
}       

$txt=$lon . ',' . $lat. ',' . $heading. ',' . $speed;
print $txt;
exit;

           
//print "\n$resp\n";

////////////////////////////////////////////////////////////////////////////

if ($speed < 2){
  $tilt="<tilt>0</tilt>";
  $heading=0;
  $altitude=5000;
  $tacho='';
}else{
  $tilt="<tilt>68</tilt>";
  //$altitude=220;
  $altitude=210;
  $range="<range>1100</range>";
  $tspeed=round($speed*1.875,0);
  $theading=round(($heading/10),0)*10;
  $vfile="http://localhost:85/seekarte/GE-Tacho/" . $tspeed . "kmh.png";
  $hfile="http://localhost:85/seekarte/GE-Tacho/" . $theading . "Grad.png";
  
  $tacho='
  
<ScreenOverlay>
    <name>Geschwindigkeit</name>
    <Icon>
      <href>' . $vfile . '</href>
    </Icon>
    <overlayXY x="0" y="1" xunits="pixels" yunits="pixels"/>
    <screenXY x="115" y="50" xunits="pixels" yunits="pixels"/>
    <rotationXY x="0" y="0" xunits="fraction" yunits="fraction"/>
    <size x="0" y="0" xunits="fraction" yunits="fraction"/>
</ScreenOverlay>

<ScreenOverlay>
    <name>Richtung</name>
    <Icon>
      <href>' . $hfile . '</href>
    </Icon>
    <overlayXY x="0" y="1" xunits="pixels" yunits="pixels"/>
    <screenXY x="115" y="80" xunits="pixels" yunits="pixels"/>
    <rotationXY x="0" y="0" xunits="fraction" yunits="fraction"/>
    <size x="0" y="0" xunits="fraction" yunits="fraction"/>
</ScreenOverlay>

';

}


$handle = fopen("kursverlauf.kml","w");

$kml='<?xml version="1.0" standalone="yes"?>
<kml xmlns="http://earth.google.com/kml/2.0">
<Document>

' . $tacho . '


    <LookAt>
      <longitude>' . $lon . '</longitude>
      <latitude>' . $lat . '</latitude>
      <altitude>' . $altitude . '</altitude>' . $tilt . $range . '
      <altitudeMode>relativeToGround</altitudeMode>
      <heading>' . $heading . '</heading>
    </LookAt>

  <Placemark><name>aktuelle Position:</name>
    <description><![CDATA[<center>Breite: ' . $lat . '<br />L&auml;nge: ' . $lon . '<br />
         <br />
         <a href="http://localhost:85/seekarte/ft-editpois.php?site=38&infotyp=1&newgps=1&bdez=' . $lat . '&ldez=' . $lon . '">Neues Seezeichen</a>
         <br />(Wird nur in Openlayers dargestellt!)<br />]]>
    </description>

    <Style id="default+icon=/usr/local/bin/gps-server.png">
      <IconStyle>
        <scale>1</scale>
        <Icon>
           <href>http://localhost:85/seekarte/ft-center.png</href>
        </Icon>
      </IconStyle>
      <LabelStyle>
        <scale>1</scale>
      </LabelStyle>
      <visibility>1</visibility>
      <open>1</open>
      <LabelStyle><color>0</color></LabelStyle>
      <LineStyle>
        <color>ffffff00</color>
        <width>5</width>
      </LineStyle>
      <PolyStyle><color>aaffff00</color></PolyStyle>
    </Style>

    <Point>
      <coordinates>
        ' . $lon . ',' . $lat . ',600
      </coordinates>
    </Point>
  </Placemark>

</Document>
</kml>
';

fwrite($handle,$kml);

fclose($handle);

$handle = fopen("kursverlauf.gps","w");
$txt=$lon . ',' . $lat. ',' . $heading. ',' . $speed;
fwrite($handle,$txt);
fclose($handle);

?>
